"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chrec_json_service_1 = require("./service/chrec-json.service");
class Core {
    constructor() {
        this.chrecJsonService = new chrec_json_service_1.ChrecJsonService();
    }
    testProject(project, settings) {
        return __awaiter(this, void 0, void 0, function* () {
            yield project.test(settings);
        });
    }
    testSequence(sequence, settings) {
        return __awaiter(this, void 0, void 0, function* () {
            yield sequence.test(settings);
        });
    }
    exportChrecJson(project, dirName) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.chrecJsonService.exportChrecJson(dirName, project);
        });
    }
    importChrecJson(absolutePath) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.chrecJsonService.importChrecJson(absolutePath);
        });
    }
}
exports.Core = Core;
