"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const action_1 = require("../action");
const browser_action_test_result_1 = require("../action-test-result/browser-action-test-result");
class BrowserAction extends action_1.Action {
    constructor(testResults, image, id) {
        super(testResults, image, id);
    }
    addTestResult(testResult) {
        this.testResults.push(testResult);
    }
    test(browser, driver) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                yield this.testBrowserAction(driver);
                this.addTestResult(new browser_action_test_result_1.BrowserActionTestResult(browser, true));
            }
            catch (error) {
                this.addTestResult(new browser_action_test_result_1.BrowserActionTestResult(browser, false));
            }
        });
    }
}
exports.BrowserAction = BrowserAction;
