import { WebDriver, WebElement } from 'selenium-webdriver';
import { Action } from '../action';
import { HtmlElementActionTestResult } from '../action-test-result/html-element-action-test-result';
import { BoundingBox } from '../bounding-box';
import { Browser } from '../browser';
import { Locator } from '../locator';
export declare abstract class HtmlElementAction extends Action {
    locators: Locator[];
    boundingBox: BoundingBox;
    constructor(testResults: HtmlElementActionTestResult[], image: string, locators: Locator[], boundingBox: BoundingBox, id?: string);
    addTestResult(testResult: HtmlElementActionTestResult): void;
    addLocator(locator: Locator): void;
    recommendedLocator(): Locator | null;
    test(browser: Browser, driver: WebDriver): Promise<void>;
    protected abstract testElement(driver: WebDriver, element: WebElement): Promise<void>;
}
