import { Locator as SeleniumLocator, WebDriver, WebElement } from 'selenium-webdriver';
import { Identificable } from './identififable';
import { LocatorTestResult } from './locator-test-result';
export declare enum Method {
    CSS_SELECTOR_GENERATOR = "CssSelectorGenerator",
    FINDER = "Finder",
    GET_QUERY_SELECTOR = "GetQuerySelector",
    OPTIMAL_SELECT = "OptimalSelect",
    SELECTOR_QUERY = "SelectorQuery",
    ROBULA_PLUS = "RobulaPlus"
}
export declare abstract class Locator extends Identificable {
    testResults: LocatorTestResult[];
    method: Method;
    value: string;
    constructor(testResults: LocatorTestResult[], method: Method, value: string, id?: string);
    readonly replayable: boolean;
    toJSON(): object;
    addTestResult(testResult: LocatorTestResult): void;
    replayableTestResultCount(): number;
    test(driver: WebDriver): Promise<void>;
    findElement(driver: WebDriver): Promise<WebElement>;
    abstract toSeleniumLocator(): SeleniumLocator;
}
