"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const identififable_1 = require("./identififable");
class Project extends identififable_1.Identificable {
    constructor(name, sequences, id) {
        super(id);
        this.name = name;
        this.sequences = sequences;
    }
    addSequence(sequence) {
        this.sequences.push(sequence);
    }
    test(settings) {
        return __awaiter(this, void 0, void 0, function* () {
            for (const sequence of this.sequences) {
                yield sequence.test(settings);
            }
        });
    }
}
exports.Project = Project;
