"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const identififable_1 = require("./identififable");
class Sequence extends identififable_1.Identificable {
    constructor(name, actions, id) {
        super(id);
        this.name = name;
        this.actions = actions;
    }
    addAction(action) {
        this.actions.push(action);
    }
    test(settings) {
        return __awaiter(this, void 0, void 0, function* () {
            for (const browser of settings.browsers) {
                const driver = yield browser.buildWebDriver(settings.seleniumServerUrl);
                for (const action of this.actions) {
                    if (browser.sleepMsBetweenActions) {
                        yield driver.sleep(browser.sleepMsBetweenActions);
                    }
                    yield action.test(browser, driver);
                }
                yield driver.quit();
            }
        });
    }
}
exports.Sequence = Sequence;
